/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

"use strict";var e=require("@lexical/utils"),t=require("lexical");function n(e,...t){const n=new URL("https://lexical.dev/docs/error"),r=new URLSearchParams;r.append("code",e);for(const e of t)r.append("v",e);throw n.search=r.toString(),Error(`Minified Lexical error #${e}; visit ${n.toString()} for the full message or use the non-minified dev environment for full errors and additional helpful warnings.`)}require("prismjs"),require("prismjs/components/prism-clike"),require("prismjs/components/prism-javascript"),require("prismjs/components/prism-markup"),require("prismjs/components/prism-markdown"),require("prismjs/components/prism-c"),require("prismjs/components/prism-css"),require("prismjs/components/prism-objectivec"),require("prismjs/components/prism-sql"),require("prismjs/components/prism-powershell"),require("prismjs/components/prism-python"),require("prismjs/components/prism-rust"),require("prismjs/components/prism-swift"),require("prismjs/components/prism-typescript"),require("prismjs/components/prism-java"),require("prismjs/components/prism-cpp"),function(e){e.languages.diff={coord:[/^(?:\*{3}|-{3}|\+{3}).*$/m,/^@@.*@@$/m,/^\d.*$/m]};var t={"deleted-sign":"-","deleted-arrow":"<","inserted-sign":"+","inserted-arrow":">",unchanged:" ",diff:"!"};Object.keys(t).forEach((function(n){var r=t[n],o=[];/^\w+$/.test(n)||o.push(/\w+/.exec(n)[0]),"diff"===n&&o.push("bold"),e.languages.diff[n]={pattern:RegExp("^(?:["+r+"].*(?:\r\n?|\n|(?![\\s\\S])))+","m"),alias:o,inside:{line:{pattern:/(.)(?=[\s\S]).*(?:\r\n?|\n)?/,lookbehind:!0},prefix:{pattern:/[\s\S]/,alias:/\w+/.exec(n)[0]}}}})),Object.defineProperty(e.languages.diff,"PREFIXES",{value:t})}(Prism);const r=globalThis.Prism||window.Prism;function o(e){return"string"==typeof e?e:Array.isArray(e)?e.map(o).join(""):o(e.content)}const i=e=>{const t=/^diff-([\w-]+)/i;try{if(!e)return!1;const n=t.exec(e);return n?r.languages.hasOwnProperty("diff")&&r.languages.hasOwnProperty(n[1]):r.languages.hasOwnProperty(e)}catch(e){return!1}};function s(t,n){for(const r of t.childNodes){if(e.isHTMLElement(r)&&r.tagName===n)return!0;s(r,n)}return!1}const a="data-language",l="data-highlight-language";class c extends t.ElementNode{static getType(){return"code"}static clone(e){return new c(e.__language,e.__key)}constructor(e,t){super(t),this.__language=e||void 0,this.__isSyntaxHighlightSupported=i(e)}createDOM(t){const n=document.createElement("code");e.addClassNamesToElement(n,t.theme.code),n.setAttribute("spellcheck","false");const r=this.getLanguage();return r&&(n.setAttribute(a,r),this.getIsSyntaxHighlightSupported()&&n.setAttribute(l,r)),n}updateDOM(e,t,n){const r=this.__language,o=e.__language;return r?r!==o&&(t.setAttribute(a,r),this.__isSyntaxHighlightSupported&&t.setAttribute(l,r)):o&&(t.removeAttribute(a),e.__isSyntaxHighlightSupported&&t.removeAttribute(l)),!1}exportDOM(t){const n=document.createElement("pre");e.addClassNamesToElement(n,t._config.theme.code),n.setAttribute("spellcheck","false");const r=this.getLanguage();return r&&(n.setAttribute(a,r),this.getIsSyntaxHighlightSupported()&&n.setAttribute(l,r)),{element:n}}static importDOM(){return{code:e=>null!=e.textContent&&(/\r?\n/.test(e.textContent)||s(e,"BR"))?{conversion:f,priority:1}:null,div:()=>({conversion:p,priority:1}),pre:()=>({conversion:f,priority:0}),table:e=>m(e)?{conversion:d,priority:3}:null,td:e=>{const t=e,n=t.closest("table");return t.classList.contains("js-file-line")||n&&m(n)?{conversion:h,priority:3}:null},tr:e=>{const t=e.closest("table");return t&&m(t)?{conversion:h,priority:3}:null}}}static importJSON(e){return g().updateFromJSON(e)}updateFromJSON(e){return super.updateFromJSON(e).setLanguage(e.language)}exportJSON(){return{...super.exportJSON(),language:this.getLanguage()}}insertNewAfter(e,n=!0){const r=this.getChildren(),o=r.length;if(o>=2&&"\n"===r[o-1].getTextContent()&&"\n"===r[o-2].getTextContent()&&e.isCollapsed()&&e.anchor.key===this.__key&&e.anchor.offset===o){r[o-1].remove(),r[o-2].remove();const e=t.$createParagraphNode();return this.insertAfter(e,n),e}const{anchor:i,focus:s}=e,a=(i.isBefore(s)?i:s).getNode();if(t.$isTextNode(a)){let e=M(a);const n=[];for(;;)if(t.$isTabNode(e))n.push(t.$createTabNode()),e=e.getNextSibling();else{if(!$(e))break;{let t=0;const r=e.getTextContent(),o=e.getTextContentSize();for(;t<o&&" "===r[t];)t++;if(0!==t&&n.push(S(" ".repeat(t))),t!==o)break;e=e.getNextSibling()}}const r=a.splitText(i.offset)[0],o=0===i.offset?0:1,s=r.getIndexWithinParent()+o,l=a.getParentOrThrow(),c=[t.$createLineBreakNode(),...n];l.splice(s,0,c);const g=n[n.length-1];g?g.select():0===i.offset?r.selectPrevious():r.getNextSibling().selectNext(0,0)}if(u(a)){const{offset:n}=e.anchor;a.splice(n,0,[t.$createLineBreakNode()]),a.select(n+1,n+1)}return null}canIndent(){return!1}collapseAtStart(){const e=t.$createParagraphNode();return this.getChildren().forEach((t=>e.append(t))),this.replace(e),!0}setLanguage(e){const t=this.getWritable();return t.__language=e||void 0,t.__isSyntaxHighlightSupported=i(e),t}getLanguage(){return this.getLatest().__language}getIsSyntaxHighlightSupported(){return this.getLatest().__isSyntaxHighlightSupported}}function g(e){return t.$applyNodeReplacement(new c(e))}function u(e){return e instanceof c}function f(e){return{node:g(e.getAttribute(a))}}function p(e){const t=e,n=N(t);return n||function(e){let t=e.parentElement;for(;null!==t;){if(N(t))return!0;t=t.parentElement}return!1}(t)?{node:n?g():null}:{node:null}}function d(){return{node:g()}}function h(){return{node:null}}function N(e){return null!==e.style.fontFamily.match("monospace")}function m(e){return e.classList.contains("js-file-line-container")}const T="javascript",_={c:"C",clike:"C-like",cpp:"C++",css:"CSS",html:"HTML",java:"Java",js:"JavaScript",markdown:"Markdown",objc:"Objective-C",plain:"Plain Text",powershell:"PowerShell",py:"Python",rust:"Rust",sql:"SQL",swift:"Swift",typescript:"TypeScript",xml:"XML"},C={cpp:"cpp",java:"java",javascript:"js",md:"markdown",plaintext:"plain",python:"py",text:"plain",ts:"typescript"};function x(e){return C[e]||e}class O extends t.TextNode{constructor(e="",t,n){super(e,n),this.__highlightType=t}static getType(){return"code-highlight"}static clone(e){return new O(e.__text,e.__highlightType||void 0,e.__key)}getHighlightType(){return this.getLatest().__highlightType}setHighlightType(e){const t=this.getWritable();return t.__highlightType=e||void 0,t}canHaveFormat(){return!1}createDOM(t){const n=super.createDOM(t),r=y(t.theme,this.__highlightType);return e.addClassNamesToElement(n,r),n}updateDOM(t,n,r){const o=super.updateDOM(t,n,r),i=y(r.theme,t.__highlightType),s=y(r.theme,this.__highlightType);return i!==s&&(i&&e.removeClassNamesFromElement(n,i),s&&e.addClassNamesToElement(n,s)),o}static importJSON(e){return S().updateFromJSON(e)}updateFromJSON(e){return super.updateFromJSON(e).setHighlightType(e.highlightType)}exportJSON(){return{...super.exportJSON(),highlightType:this.getHighlightType()}}setFormat(e){return this}isParentRequired(){return!0}createParentElementNode(){return g()}}function y(e,t){return t&&e&&e.codeHighlight&&e.codeHighlight[t]}function S(e="",n){return t.$applyNodeReplacement(new O(e,n))}function $(e){return e instanceof O}function A(n,r){let o=n;for(let i=t.$getSiblingCaret(n,r);i&&($(i.origin)||t.$isTabNode(i.origin));i=e.$getAdjacentCaret(i))o=i.origin;return o}function M(e){return A(e,"previous")}function L(e){return A(e,"next")}const E={defaultLanguage:T,tokenize(e,t){return r.tokenize(e,r.languages[t||""]||r.languages[this.defaultLanguage])}};function b(e,r){let o=null,i=null,s=e,a=r,l=e.getTextContent();for(;;){if(0===a){if(s=s.getPreviousSibling(),null===s)break;if($(s)||t.$isTabNode(s)||t.$isLineBreakNode(s)||n(167),t.$isLineBreakNode(s)){o={node:s,offset:1};break}a=Math.max(0,s.getTextContentSize()-1),l=s.getTextContent()}else a--;const e=l[a];$(s)&&" "!==e&&(i={node:s,offset:a})}if(null!==i)return i;let c=null;if(r<e.getTextContentSize())$(e)&&(c=e.getTextContent()[r]);else{const t=e.getNextSibling();$(t)&&(c=t.getTextContent()[0])}if(null!==c&&" "!==c)return o;{const n=function(e,n){let r=e,o=n,i=e.getTextContent(),s=e.getTextContentSize();for(;;){if(!$(r)||o===s){if(r=r.getNextSibling(),null===r||t.$isLineBreakNode(r))return null;$(r)&&(o=0,i=r.getTextContent(),s=r.getTextContentSize())}if($(r)){if(" "!==i[o])return{node:r,offset:o};o++}}}(e,r);return null!==n?n:o}}function v(e){const r=L(e);return t.$isLineBreakNode(r)&&n(168),r}function D(e,n,r){const o=e.getParent();u(o)?k(o,n,r):$(e)&&e.replace(t.$createTextNode(e.__text))}function R(e,n){const r=n.getElementByKey(e.getKey());if(null===r)return;const o=e.getChildren(),i=o.length;if(i===r.__cachedChildrenLength)return;r.__cachedChildrenLength=i;let s="1",a=1;for(let e=0;e<i;e++)t.$isLineBreakNode(o[e])&&(s+="\n"+ ++a);r.setAttribute("data-gutter",s)}const P=new Set;function k(e,n,i){const s=e.getKey();P.has(s)||(P.add(s),void 0===e.getLanguage()&&e.setLanguage(i.defaultLanguage),n.update((()=>{!function(e,n){const r=t.$getNodeByKey(e);if(!u(r)||!r.isAttached())return;const o=t.$getSelection();if(!t.$isRangeSelection(o))return void n();const i=o.anchor,s=i.offset,a="element"===i.type&&t.$isLineBreakNode(r.getChildAtIndex(i.offset-1));let l=0;if(!a){const e=i.getNode();l=s+e.getPreviousSiblings().reduce(((e,t)=>e+t.getTextContentSize()),0)}if(!n())return;if(a)return void i.getNode().select(s,s);r.getChildren().some((e=>{const n=t.$isTextNode(e);if(n||t.$isLineBreakNode(e)){const t=e.getTextContentSize();if(n&&t>=l)return e.select(l,l),!0;l-=t}return!1}))}(s,(()=>{const n=t.$getNodeByKey(s);if(!u(n)||!n.isAttached())return!1;const a=n.getLanguage()||i.defaultLanguage,l=/^diff-([\w-]+)/i.exec(a),c=n.getTextContent();let g=i.tokenize(c,l?"diff":a);l&&(g=function(e,t){const n=t,i=r.languages[n],s={tokens:e},a=r.languages.diff.PREFIXES;for(const e of s.tokens){if("string"==typeof e||!(e.type in a)||!Array.isArray(e.content))continue;const t=e.type;let n=0;const s=()=>(n++,new r.Token("prefix",a[t],t.replace(/^(\w+).*/,"$1"))),l=e.content.filter((e=>"string"==typeof e||"prefix"!==e.type)),c=e.content.length-l.length,g=r.tokenize(o(l),i);g.unshift(s());const u=/\r\n|\n/g,f=e=>{const t=[];u.lastIndex=0;let r,o=0;for(;n<c&&(r=u.exec(e));){const n=r.index+r[0].length;t.push(e.slice(o,n)),o=n,t.push(s())}if(0!==t.length)return o<e.length&&t.push(e.slice(o)),t},p=e=>{for(let t=0;t<e.length&&n<c;t++){const n=e[t];if("string"==typeof n){const r=f(n);r&&(e.splice(t,1,...r),t+=r.length-1)}else if("string"==typeof n.content){const e=f(n.content);e&&(n.content=e)}else Array.isArray(n.content)?p(n.content):p([n.content])}};p(g),n<c&&g.push(s()),e.content=g}return s.tokens}(g,l[1]));const f=w(g),p=function(e,t){let n=0;for(;n<e.length&&B(e[n],t[n]);)n++;const r=e.length,o=t.length,i=Math.min(r,o)-n;let s=0;for(;s<i;)if(s++,!B(e[r-s],t[o-s])){s--;break}const a=n,l=r-s,c=t.slice(n,o-s);return{from:a,nodesForReplacement:c,to:l}}(n.getChildren(),f),{from:d,to:h,nodesForReplacement:N}=p;return!(d===h&&!N.length)&&(e.splice(d,h-d,N),!0)}))}),{onUpdate:()=>{P.delete(s)},skipTransforms:!0}))}function w(e,n){const r=[];for(const o of e)if("string"==typeof o){const e=o.split(/(\n|\t)/),i=e.length;for(let o=0;o<i;o++){const i=e[o];"\n"===i||"\r\n"===i?r.push(t.$createLineBreakNode()):"\t"===i?r.push(t.$createTabNode()):i.length>0&&r.push(S(i,n))}}else{const{content:e,alias:t}=o;"string"==typeof e?r.push(...w([e],"prefix"===o.type&&"string"==typeof t?t:o.type)):Array.isArray(e)&&r.push(...w(e,"unchanged"===o.type?void 0:o.type))}return r}function B(e,n){return $(e)&&$(n)&&e.__text===n.__text&&e.__highlightType===n.__highlightType||t.$isTabNode(e)&&t.$isTabNode(n)||t.$isLineBreakNode(e)&&t.$isLineBreakNode(n)}function I(e){if(!t.$isRangeSelection(e))return!1;const n=e.anchor.getNode(),r=u(n)?n:n.getParent(),o=e.focus.getNode(),i=u(o)?o:o.getParent();return u(r)&&r.is(i)}function j(e){const r=e.getNodes(),o=[];if(1===r.length&&u(r[0]))return o;let i=[];for(let e=0;e<r.length;e++){const s=r[e];$(s)||t.$isTabNode(s)||t.$isLineBreakNode(s)||n(169),t.$isLineBreakNode(s)?i.length>0&&(o.push(i),i=[]):i.push(s)}if(i.length>0){const n=e.isBackward()?e.anchor:e.focus,r=t.$createPoint(i[0].getKey(),0,"text");n.is(r)||o.push(i)}return o}function H(e){const n=t.$getSelection();if(!t.$isRangeSelection(n)||!I(n))return!1;const r=j(n),o=r.length;if(0===o&&n.isCollapsed())return e===t.INDENT_CONTENT_COMMAND&&n.insertNodes([t.$createTabNode()]),!0;if(0===o&&e===t.INDENT_CONTENT_COMMAND&&"\n"===n.getTextContent()){const e=t.$createTabNode(),r=t.$createLineBreakNode(),o=n.isBackward()?"previous":"next";return n.insertNodes([e,r]),t.$setSelectionFromCaretRange(t.$getCaretRangeInDirection(t.$getCaretRange(t.$getTextPointCaret(e,"next",0),t.$normalizeCaret(t.$getSiblingCaret(r,"next"))),o)),!0}for(let i=0;i<o;i++){const o=r[i];if(o.length>0){let r=o[0];if(0===i&&(r=M(r)),e===t.INDENT_CONTENT_COMMAND){const e=t.$createTabNode();if(r.insertBefore(e),0===i){const o=n.isBackward()?"focus":"anchor",i=t.$createPoint(r.getKey(),0,"text");n[o].is(i)&&n[o].set(e.getKey(),0,"text")}}else t.$isTabNode(r)&&r.remove()}}return!0}function q(e,n){const r=t.$getSelection();if(!t.$isRangeSelection(r))return!1;const{anchor:o,focus:i}=r,s=o.offset,a=i.offset,l=o.getNode(),c=i.getNode(),g=e===t.KEY_ARROW_UP_COMMAND;if(!I(r)||!$(l)&&!t.$isTabNode(l)||!$(c)&&!t.$isTabNode(c))return!1;if(!n.altKey){if(r.isCollapsed()){const e=l.getParentOrThrow();if(g&&0===s&&null===l.getPreviousSibling()){if(null===e.getPreviousSibling())return e.selectPrevious(),n.preventDefault(),!0}else if(!g&&s===l.getTextContentSize()&&null===l.getNextSibling()){if(null===e.getNextSibling())return e.selectNext(),n.preventDefault(),!0}}return!1}let u,f;if(l.isBefore(c)?(u=M(l),f=L(c)):(u=M(c),f=L(l)),null==u||null==f)return!1;const p=u.getNodesBetween(f);for(let e=0;e<p.length;e++){const n=p[e];if(!$(n)&&!t.$isTabNode(n)&&!t.$isLineBreakNode(n))return!1}n.preventDefault(),n.stopPropagation();const d=g?u.getPreviousSibling():f.getNextSibling();if(!t.$isLineBreakNode(d))return!0;const h=g?d.getPreviousSibling():d.getNextSibling();if(null==h)return!0;const N=$(h)||t.$isTabNode(h)||t.$isLineBreakNode(h)?g?M(h):L(h):null;let m=null!=N?N:h;return d.remove(),p.forEach((e=>e.remove())),e===t.KEY_ARROW_UP_COMMAND?(p.forEach((e=>m.insertBefore(e))),m.insertBefore(d)):(m.insertAfter(d),m=d,p.forEach((e=>{m.insertAfter(e),m=e}))),r.setTextNodeRange(l,s,c,a),!0}function F(e,n){const r=t.$getSelection();if(!t.$isRangeSelection(r))return!1;const{anchor:o,focus:i}=r,s=o.getNode(),a=i.getNode(),l=e===t.MOVE_TO_START;if(!I(r)||!$(s)&&!t.$isTabNode(s)||!$(a)&&!t.$isTabNode(a))return!1;if(l){const e=b(a,i.offset);if(null!==e){const{node:n,offset:o}=e;t.$isLineBreakNode(n)?n.selectNext(0,0):r.setTextNodeRange(n,o,n,o)}else a.getParentOrThrow().selectStart()}else{v(a).select()}return n.preventDefault(),n.stopPropagation(),!0}const K=M,W=L,z=v,Y=b;exports.$createCodeHighlightNode=S,exports.$createCodeNode=g,exports.$getEndOfCodeInLine=v,exports.$getFirstCodeNodeOfLine=M,exports.$getLastCodeNodeOfLine=L,exports.$getStartOfCodeInLine=b,exports.$isCodeHighlightNode=$,exports.$isCodeNode=u,exports.CODE_LANGUAGE_FRIENDLY_NAME_MAP=_,exports.CODE_LANGUAGE_MAP=C,exports.CodeHighlightNode=O,exports.CodeNode=c,exports.DEFAULT_CODE_LANGUAGE=T,exports.PrismTokenizer=E,exports.getCodeLanguages=()=>Object.keys(r.languages).filter((e=>"function"!=typeof r.languages[e])).sort(),exports.getDefaultCodeLanguage=()=>T,exports.getEndOfCodeInLine=z,exports.getFirstCodeNodeOfLine=K,exports.getLanguageFriendlyName=function(e){const t=x(e);return _[t]||t},exports.getLastCodeNodeOfLine=W,exports.getStartOfCodeInLine=Y,exports.normalizeCodeLang=x,exports.registerCodeHighlighting=function(r,o){if(!r.hasNodes([c,O]))throw new Error("CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor");null==o&&(o=E);const i=[];return!0!==r._headless&&i.push(r.registerMutationListener(c,(e=>{r.update((()=>{for(const[n,o]of e)if("destroyed"!==o){const e=t.$getNodeByKey(n);null!==e&&R(e,r)}}))}),{skipInitialization:!1})),i.push(r.registerNodeTransform(c,(e=>k(e,r,o))),r.registerNodeTransform(t.TextNode,(e=>D(e,r,o))),r.registerNodeTransform(O,(e=>D(e,r,o))),r.registerCommand(t.KEY_TAB_COMMAND,(e=>{const o=function(e){const r=t.$getSelection();if(!t.$isRangeSelection(r)||!I(r))return null;const o=e?t.OUTDENT_CONTENT_COMMAND:t.INDENT_CONTENT_COMMAND,i=e?t.OUTDENT_CONTENT_COMMAND:t.INSERT_TAB_COMMAND,s=r.anchor,a=r.focus;if(s.is(a))return i;const l=j(r);if(1!==l.length)return o;const c=l[0];let g,u;0===c.length&&n(285),r.isBackward()?(g=a,u=s):(g=s,u=a);const f=M(c[0]),p=L(c[0]),d=t.$createPoint(f.getKey(),0,"text"),h=t.$createPoint(p.getKey(),p.getTextContentSize(),"text");return g.isBefore(d)||h.isBefore(u)?o:d.isBefore(g)||u.isBefore(h)?i:o}(e.shiftKey);return null!==o&&(e.preventDefault(),r.dispatchCommand(o,void 0),!0)}),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.INSERT_TAB_COMMAND,(()=>!!I(t.$getSelection())&&(t.$insertNodes([t.$createTabNode()]),!0)),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.INDENT_CONTENT_COMMAND,(e=>H(t.INDENT_CONTENT_COMMAND)),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.OUTDENT_CONTENT_COMMAND,(e=>H(t.OUTDENT_CONTENT_COMMAND)),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.KEY_ARROW_UP_COMMAND,(e=>{const n=t.$getSelection();if(!t.$isRangeSelection(n))return!1;const{anchor:r}=n,o=r.getNode();return!!I(n)&&(n.isCollapsed()&&0===r.offset&&null===o.getPreviousSibling()&&u(o.getParentOrThrow())?(e.preventDefault(),!0):q(t.KEY_ARROW_UP_COMMAND,e))}),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.KEY_ARROW_DOWN_COMMAND,(e=>{const n=t.$getSelection();if(!t.$isRangeSelection(n))return!1;const{anchor:r}=n,o=r.getNode();return!!I(n)&&(n.isCollapsed()&&r.offset===o.getTextContentSize()&&null===o.getNextSibling()&&u(o.getParentOrThrow())?(e.preventDefault(),!0):q(t.KEY_ARROW_DOWN_COMMAND,e))}),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.MOVE_TO_START,(e=>F(t.MOVE_TO_START,e)),t.COMMAND_PRIORITY_LOW),r.registerCommand(t.MOVE_TO_END,(e=>F(t.MOVE_TO_END,e)),t.COMMAND_PRIORITY_LOW)),e.mergeRegister(...i)};
