/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

import{isHTMLElement as t,addClassNamesToElement as e,removeClassNamesFromElement as n,$getAdjacentCaret as r,mergeRegister as o}from"@lexical/utils";import{ElementNode as i,$createParagraphNode as s,$isTextNode as l,$isTabNode as c,$createTabNode as u,$createLineBreakNode as a,$applyNodeReplacement as g,TextNode as f,$getSiblingCaret as p,$isLineBreakNode as h,$createTextNode as d,$getNodeByKey as m,$getSelection as x,$isRangeSelection as y,$createPoint as S,INDENT_CONTENT_COMMAND as v,OUTDENT_CONTENT_COMMAND as _,INSERT_TAB_COMMAND as T,$setSelectionFromCaretRange as C,$getCaretRangeInDirection as N,$getCaretRange as j,$getTextPointCaret as b,$normalizeCaret as w,KEY_ARROW_UP_COMMAND as k,MOVE_TO_START as P,KEY_TAB_COMMAND as O,COMMAND_PRIORITY_LOW as A,$insertNodes as L,KEY_ARROW_DOWN_COMMAND as E,MOVE_TO_END as H}from"lexical";import"prismjs";import"prismjs/components/prism-clike.js";import"prismjs/components/prism-javascript.js";import"prismjs/components/prism-markup.js";import"prismjs/components/prism-markdown.js";import"prismjs/components/prism-c.js";import"prismjs/components/prism-css.js";import"prismjs/components/prism-objectivec.js";import"prismjs/components/prism-sql.js";import"prismjs/components/prism-powershell.js";import"prismjs/components/prism-python.js";import"prismjs/components/prism-rust.js";import"prismjs/components/prism-swift.js";import"prismjs/components/prism-typescript.js";import"prismjs/components/prism-java.js";import"prismjs/components/prism-cpp.js";function B(t,...e){const n=new URL("https://lexical.dev/docs/error"),r=new URLSearchParams;r.append("code",t);for(const t of e)r.append("v",t);throw n.search=r.toString(),Error(`Minified Lexical error #${t}; visit ${n.toString()} for the full message or use the non-minified dev environment for full errors and additional helpful warnings.`)}!function(t){t.languages.diff={coord:[/^(?:\*{3}|-{3}|\+{3}).*$/m,/^@@.*@@$/m,/^\d.*$/m]};var e={"deleted-sign":"-","deleted-arrow":"<","inserted-sign":"+","inserted-arrow":">",unchanged:" ",diff:"!"};Object.keys(e).forEach((function(n){var r=e[n],o=[];/^\w+$/.test(n)||o.push(/\w+/.exec(n)[0]),"diff"===n&&o.push("bold"),t.languages.diff[n]={pattern:RegExp("^(?:["+r+"].*(?:\r\n?|\n|(?![\\s\\S])))+","m"),alias:o,inside:{line:{pattern:/(.)(?=[\s\S]).*(?:\r\n?|\n)?/,lookbehind:!0},prefix:{pattern:/[\s\S]/,alias:/\w+/.exec(n)[0]}}}})),Object.defineProperty(t.languages.diff,"PREFIXES",{value:e})}(Prism);const z=globalThis.Prism||window.Prism;function D(t){return"string"==typeof t?t:Array.isArray(t)?t.map(D).join(""):D(t.content)}const M=t=>{const e=/^diff-([\w-]+)/i;try{if(!t)return!1;const n=e.exec(t);return n?z.languages.hasOwnProperty("diff")&&z.languages.hasOwnProperty(n[1]):z.languages.hasOwnProperty(t)}catch(t){return!1}};function J(e,n){for(const r of e.childNodes){if(t(r)&&r.tagName===n)return!0;J(r,n)}return!1}const F="data-language",R="data-highlight-language";class I extends i{static getType(){return"code"}static clone(t){return new I(t.__language,t.__key)}constructor(t,e){super(e),this.__language=t||void 0,this.__isSyntaxHighlightSupported=M(t)}createDOM(t){const n=document.createElement("code");e(n,t.theme.code),n.setAttribute("spellcheck","false");const r=this.getLanguage();return r&&(n.setAttribute(F,r),this.getIsSyntaxHighlightSupported()&&n.setAttribute(R,r)),n}updateDOM(t,e,n){const r=this.__language,o=t.__language;return r?r!==o&&(e.setAttribute(F,r),this.__isSyntaxHighlightSupported&&e.setAttribute(R,r)):o&&(e.removeAttribute(F),t.__isSyntaxHighlightSupported&&e.removeAttribute(R)),!1}exportDOM(t){const n=document.createElement("pre");e(n,t._config.theme.code),n.setAttribute("spellcheck","false");const r=this.getLanguage();return r&&(n.setAttribute(F,r),this.getIsSyntaxHighlightSupported()&&n.setAttribute(R,r)),{element:n}}static importDOM(){return{code:t=>null!=t.textContent&&(/\r?\n/.test(t.textContent)||J(t,"BR"))?{conversion:q,priority:1}:null,div:()=>({conversion:U,priority:1}),pre:()=>({conversion:q,priority:0}),table:t=>G(t)?{conversion:W,priority:3}:null,td:t=>{const e=t,n=e.closest("table");return e.classList.contains("js-file-line")||n&&G(n)?{conversion:X,priority:3}:null},tr:t=>{const e=t.closest("table");return e&&G(e)?{conversion:X,priority:3}:null}}}static importJSON(t){return K().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setLanguage(t.language)}exportJSON(){return{...super.exportJSON(),language:this.getLanguage()}}insertNewAfter(t,e=!0){const n=this.getChildren(),r=n.length;if(r>=2&&"\n"===n[r-1].getTextContent()&&"\n"===n[r-2].getTextContent()&&t.isCollapsed()&&t.anchor.key===this.__key&&t.anchor.offset===r){n[r-1].remove(),n[r-2].remove();const t=s();return this.insertAfter(t,e),t}const{anchor:o,focus:i}=t,g=(o.isBefore(i)?o:i).getNode();if(l(g)){let t=ut(g);const e=[];for(;;)if(c(t))e.push(u()),t=t.getNextSibling();else{if(!lt(t))break;{let n=0;const r=t.getTextContent(),o=t.getTextContentSize();for(;n<o&&" "===r[n];)n++;if(0!==n&&e.push(st(" ".repeat(n))),n!==o)break;t=t.getNextSibling()}}const n=g.splitText(o.offset)[0],r=0===o.offset?0:1,i=n.getIndexWithinParent()+r,s=g.getParentOrThrow(),l=[a(),...e];s.splice(i,0,l);const f=e[e.length-1];f?f.select():0===o.offset?n.selectPrevious():n.getNextSibling().selectNext(0,0)}if($(g)){const{offset:e}=t.anchor;g.splice(e,0,[a()]),g.select(e+1,e+1)}return null}canIndent(){return!1}collapseAtStart(){const t=s();return this.getChildren().forEach((e=>t.append(e))),this.replace(t),!0}setLanguage(t){const e=this.getWritable();return e.__language=t||void 0,e.__isSyntaxHighlightSupported=M(t),e}getLanguage(){return this.getLatest().__language}getIsSyntaxHighlightSupported(){return this.getLatest().__isSyntaxHighlightSupported}}function K(t){return g(new I(t))}function $(t){return t instanceof I}function q(t){return{node:K(t.getAttribute(F))}}function U(t){const e=t,n=Q(e);return n||function(t){let e=t.parentElement;for(;null!==e;){if(Q(e))return!0;e=e.parentElement}return!1}(e)?{node:n?K():null}:{node:null}}function W(){return{node:K()}}function X(){return{node:null}}function Q(t){return null!==t.style.fontFamily.match("monospace")}function G(t){return t.classList.contains("js-file-line-container")}const V="javascript",Y={c:"C",clike:"C-like",cpp:"C++",css:"CSS",html:"HTML",java:"Java",js:"JavaScript",markdown:"Markdown",objc:"Objective-C",plain:"Plain Text",powershell:"PowerShell",py:"Python",rust:"Rust",sql:"SQL",swift:"Swift",typescript:"TypeScript",xml:"XML"},Z={cpp:"cpp",java:"java",javascript:"js",md:"markdown",plaintext:"plain",python:"py",text:"plain",ts:"typescript"};function tt(t){return Z[t]||t}function et(t){const e=tt(t);return Y[e]||e}const nt=()=>V,rt=()=>Object.keys(z.languages).filter((t=>"function"!=typeof z.languages[t])).sort();class ot extends f{constructor(t="",e,n){super(t,n),this.__highlightType=e}static getType(){return"code-highlight"}static clone(t){return new ot(t.__text,t.__highlightType||void 0,t.__key)}getHighlightType(){return this.getLatest().__highlightType}setHighlightType(t){const e=this.getWritable();return e.__highlightType=t||void 0,e}canHaveFormat(){return!1}createDOM(t){const n=super.createDOM(t),r=it(t.theme,this.__highlightType);return e(n,r),n}updateDOM(t,r,o){const i=super.updateDOM(t,r,o),s=it(o.theme,t.__highlightType),l=it(o.theme,this.__highlightType);return s!==l&&(s&&n(r,s),l&&e(r,l)),i}static importJSON(t){return st().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setHighlightType(t.highlightType)}exportJSON(){return{...super.exportJSON(),highlightType:this.getHighlightType()}}setFormat(t){return this}isParentRequired(){return!0}createParentElementNode(){return K()}}function it(t,e){return e&&t&&t.codeHighlight&&t.codeHighlight[e]}function st(t="",e){return g(new ot(t,e))}function lt(t){return t instanceof ot}function ct(t,e){let n=t;for(let o=p(t,e);o&&(lt(o.origin)||c(o.origin));o=r(o))n=o.origin;return n}function ut(t){return ct(t,"previous")}function at(t){return ct(t,"next")}const gt={defaultLanguage:V,tokenize(t,e){return z.tokenize(t,z.languages[e||""]||z.languages[this.defaultLanguage])}};function ft(t,e){let n=null,r=null,o=t,i=e,s=t.getTextContent();for(;;){if(0===i){if(o=o.getPreviousSibling(),null===o)break;if(lt(o)||c(o)||h(o)||B(167),h(o)){n={node:o,offset:1};break}i=Math.max(0,o.getTextContentSize()-1),s=o.getTextContent()}else i--;const t=s[i];lt(o)&&" "!==t&&(r={node:o,offset:i})}if(null!==r)return r;let l=null;if(e<t.getTextContentSize())lt(t)&&(l=t.getTextContent()[e]);else{const e=t.getNextSibling();lt(e)&&(l=e.getTextContent()[0])}if(null!==l&&" "!==l)return n;{const r=function(t,e){let n=t,r=e,o=t.getTextContent(),i=t.getTextContentSize();for(;;){if(!lt(n)||r===i){if(n=n.getNextSibling(),null===n||h(n))return null;lt(n)&&(r=0,o=n.getTextContent(),i=n.getTextContentSize())}if(lt(n)){if(" "!==o[r])return{node:n,offset:r};r++}}}(t,e);return null!==r?r:n}}function pt(t){const e=at(t);return h(e)&&B(168),e}function ht(t,e,n){const r=t.getParent();$(r)?xt(r,e,n):lt(t)&&t.replace(d(t.__text))}function dt(t,e){const n=e.getElementByKey(t.getKey());if(null===n)return;const r=t.getChildren(),o=r.length;if(o===n.__cachedChildrenLength)return;n.__cachedChildrenLength=o;let i="1",s=1;for(let t=0;t<o;t++)h(r[t])&&(i+="\n"+ ++s);n.setAttribute("data-gutter",i)}const mt=new Set;function xt(t,e,n){const r=t.getKey();mt.has(r)||(mt.add(r),void 0===t.getLanguage()&&t.setLanguage(n.defaultLanguage),e.update((()=>{!function(t,e){const n=m(t);if(!$(n)||!n.isAttached())return;const r=x();if(!y(r))return void e();const o=r.anchor,i=o.offset,s="element"===o.type&&h(n.getChildAtIndex(o.offset-1));let c=0;if(!s){const t=o.getNode();c=i+t.getPreviousSiblings().reduce(((t,e)=>t+e.getTextContentSize()),0)}if(!e())return;if(s)return void o.getNode().select(i,i);n.getChildren().some((t=>{const e=l(t);if(e||h(t)){const n=t.getTextContentSize();if(e&&n>=c)return t.select(c,c),!0;c-=n}return!1}))}(r,(()=>{const e=m(r);if(!$(e)||!e.isAttached())return!1;const o=e.getLanguage()||n.defaultLanguage,i=/^diff-([\w-]+)/i.exec(o),s=e.getTextContent();let l=n.tokenize(s,i?"diff":o);i&&(l=function(t,e){const n=e,r=z.languages[n],o={tokens:t},i=z.languages.diff.PREFIXES;for(const t of o.tokens){if("string"==typeof t||!(t.type in i)||!Array.isArray(t.content))continue;const e=t.type;let n=0;const o=()=>(n++,new z.Token("prefix",i[e],e.replace(/^(\w+).*/,"$1"))),s=t.content.filter((t=>"string"==typeof t||"prefix"!==t.type)),l=t.content.length-s.length,c=z.tokenize(D(s),r);c.unshift(o());const u=/\r\n|\n/g,a=t=>{const e=[];u.lastIndex=0;let r,i=0;for(;n<l&&(r=u.exec(t));){const n=r.index+r[0].length;e.push(t.slice(i,n)),i=n,e.push(o())}if(0!==e.length)return i<t.length&&e.push(t.slice(i)),e},g=t=>{for(let e=0;e<t.length&&n<l;e++){const n=t[e];if("string"==typeof n){const r=a(n);r&&(t.splice(e,1,...r),e+=r.length-1)}else if("string"==typeof n.content){const t=a(n.content);t&&(n.content=t)}else Array.isArray(n.content)?g(n.content):g([n.content])}};g(c),n<l&&c.push(o()),t.content=c}return o.tokens}(l,i[1]));const c=yt(l),u=function(t,e){let n=0;for(;n<t.length&&St(t[n],e[n]);)n++;const r=t.length,o=e.length,i=Math.min(r,o)-n;let s=0;for(;s<i;)if(s++,!St(t[r-s],e[o-s])){s--;break}const l=n,c=r-s,u=e.slice(n,o-s);return{from:l,nodesForReplacement:u,to:c}}(e.getChildren(),c),{from:a,to:g,nodesForReplacement:f}=u;return!(a===g&&!f.length)&&(t.splice(a,g-a,f),!0)}))}),{onUpdate:()=>{mt.delete(r)},skipTransforms:!0}))}function yt(t,e){const n=[];for(const r of t)if("string"==typeof r){const t=r.split(/(\n|\t)/),o=t.length;for(let r=0;r<o;r++){const o=t[r];"\n"===o||"\r\n"===o?n.push(a()):"\t"===o?n.push(u()):o.length>0&&n.push(st(o,e))}}else{const{content:t,alias:e}=r;"string"==typeof t?n.push(...yt([t],"prefix"===r.type&&"string"==typeof e?e:r.type)):Array.isArray(t)&&n.push(...yt(t,"unchanged"===r.type?void 0:r.type))}return n}function St(t,e){return lt(t)&&lt(e)&&t.__text===e.__text&&t.__highlightType===e.__highlightType||c(t)&&c(e)||h(t)&&h(e)}function vt(t){if(!y(t))return!1;const e=t.anchor.getNode(),n=$(e)?e:e.getParent(),r=t.focus.getNode(),o=$(r)?r:r.getParent();return $(n)&&n.is(o)}function _t(t){const e=t.getNodes(),n=[];if(1===e.length&&$(e[0]))return n;let r=[];for(let t=0;t<e.length;t++){const o=e[t];lt(o)||c(o)||h(o)||B(169),h(o)?r.length>0&&(n.push(r),r=[]):r.push(o)}if(r.length>0){const e=t.isBackward()?t.anchor:t.focus,o=S(r[0].getKey(),0,"text");e.is(o)||n.push(r)}return n}function Tt(t){const e=x();if(!y(e)||!vt(e))return!1;const n=_t(e),r=n.length;if(0===r&&e.isCollapsed())return t===v&&e.insertNodes([u()]),!0;if(0===r&&t===v&&"\n"===e.getTextContent()){const t=u(),n=a(),r=e.isBackward()?"previous":"next";return e.insertNodes([t,n]),C(N(j(b(t,"next",0),w(p(n,"next"))),r)),!0}for(let o=0;o<r;o++){const r=n[o];if(r.length>0){let n=r[0];if(0===o&&(n=ut(n)),t===v){const t=u();if(n.insertBefore(t),0===o){const r=e.isBackward()?"focus":"anchor",o=S(n.getKey(),0,"text");e[r].is(o)&&e[r].set(t.getKey(),0,"text")}}else c(n)&&n.remove()}}return!0}function Ct(t,e){const n=x();if(!y(n))return!1;const{anchor:r,focus:o}=n,i=r.offset,s=o.offset,l=r.getNode(),u=o.getNode(),a=t===k;if(!vt(n)||!lt(l)&&!c(l)||!lt(u)&&!c(u))return!1;if(!e.altKey){if(n.isCollapsed()){const t=l.getParentOrThrow();if(a&&0===i&&null===l.getPreviousSibling()){if(null===t.getPreviousSibling())return t.selectPrevious(),e.preventDefault(),!0}else if(!a&&i===l.getTextContentSize()&&null===l.getNextSibling()){if(null===t.getNextSibling())return t.selectNext(),e.preventDefault(),!0}}return!1}let g,f;if(l.isBefore(u)?(g=ut(l),f=at(u)):(g=ut(u),f=at(l)),null==g||null==f)return!1;const p=g.getNodesBetween(f);for(let t=0;t<p.length;t++){const e=p[t];if(!lt(e)&&!c(e)&&!h(e))return!1}e.preventDefault(),e.stopPropagation();const d=a?g.getPreviousSibling():f.getNextSibling();if(!h(d))return!0;const m=a?d.getPreviousSibling():d.getNextSibling();if(null==m)return!0;const S=lt(m)||c(m)||h(m)?a?ut(m):at(m):null;let v=null!=S?S:m;return d.remove(),p.forEach((t=>t.remove())),t===k?(p.forEach((t=>v.insertBefore(t))),v.insertBefore(d)):(v.insertAfter(d),v=d,p.forEach((t=>{v.insertAfter(t),v=t}))),n.setTextNodeRange(l,i,u,s),!0}function Nt(t,e){const n=x();if(!y(n))return!1;const{anchor:r,focus:o}=n,i=r.getNode(),s=o.getNode(),l=t===P;if(!vt(n)||!lt(i)&&!c(i)||!lt(s)&&!c(s))return!1;if(l){const t=ft(s,o.offset);if(null!==t){const{node:e,offset:r}=t;h(e)?e.selectNext(0,0):n.setTextNodeRange(e,r,e,r)}else s.getParentOrThrow().selectStart()}else{pt(s).select()}return e.preventDefault(),e.stopPropagation(),!0}function jt(t,e){if(!t.hasNodes([I,ot]))throw new Error("CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor");null==e&&(e=gt);const n=[];return!0!==t._headless&&n.push(t.registerMutationListener(I,(e=>{t.update((()=>{for(const[n,r]of e)if("destroyed"!==r){const e=m(n);null!==e&&dt(e,t)}}))}),{skipInitialization:!1})),n.push(t.registerNodeTransform(I,(n=>xt(n,t,e))),t.registerNodeTransform(f,(n=>ht(n,t,e))),t.registerNodeTransform(ot,(n=>ht(n,t,e))),t.registerCommand(O,(e=>{const n=function(t){const e=x();if(!y(e)||!vt(e))return null;const n=t?_:v,r=t?_:T,o=e.anchor,i=e.focus;if(o.is(i))return r;const s=_t(e);if(1!==s.length)return n;const l=s[0];let c,u;0===l.length&&B(285),e.isBackward()?(c=i,u=o):(c=o,u=i);const a=ut(l[0]),g=at(l[0]),f=S(a.getKey(),0,"text"),p=S(g.getKey(),g.getTextContentSize(),"text");return c.isBefore(f)||p.isBefore(u)?n:f.isBefore(c)||u.isBefore(p)?r:n}(e.shiftKey);return null!==n&&(e.preventDefault(),t.dispatchCommand(n,void 0),!0)}),A),t.registerCommand(T,(()=>!!vt(x())&&(L([u()]),!0)),A),t.registerCommand(v,(t=>Tt(v)),A),t.registerCommand(_,(t=>Tt(_)),A),t.registerCommand(k,(t=>{const e=x();if(!y(e))return!1;const{anchor:n}=e,r=n.getNode();return!!vt(e)&&(e.isCollapsed()&&0===n.offset&&null===r.getPreviousSibling()&&$(r.getParentOrThrow())?(t.preventDefault(),!0):Ct(k,t))}),A),t.registerCommand(E,(t=>{const e=x();if(!y(e))return!1;const{anchor:n}=e,r=n.getNode();return!!vt(e)&&(e.isCollapsed()&&n.offset===r.getTextContentSize()&&null===r.getNextSibling()&&$(r.getParentOrThrow())?(t.preventDefault(),!0):Ct(E,t))}),A),t.registerCommand(P,(t=>Nt(P,t)),A),t.registerCommand(H,(t=>Nt(H,t)),A)),o(...n)}const bt=ut,wt=at,kt=pt,Pt=ft;export{st as $createCodeHighlightNode,K as $createCodeNode,pt as $getEndOfCodeInLine,ut as $getFirstCodeNodeOfLine,at as $getLastCodeNodeOfLine,ft as $getStartOfCodeInLine,lt as $isCodeHighlightNode,$ as $isCodeNode,Y as CODE_LANGUAGE_FRIENDLY_NAME_MAP,Z as CODE_LANGUAGE_MAP,ot as CodeHighlightNode,I as CodeNode,V as DEFAULT_CODE_LANGUAGE,gt as PrismTokenizer,rt as getCodeLanguages,nt as getDefaultCodeLanguage,kt as getEndOfCodeInLine,bt as getFirstCodeNodeOfLine,et as getLanguageFriendlyName,wt as getLastCodeNodeOfLine,Pt as getStartOfCodeInLine,tt as normalizeCodeLang,jt as registerCodeHighlighting};
